using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "fly")]
public class Fly : Script, IScriptPreventMove, IScriptOnBeforeMove
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<ChargeFlyEffect>())
            return;

        move.User.Volatile.Add(new ChargeFlyEffect(move.User));
        move.MoveChoice.SetAdditionalData("fly_charge", true);
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("fly_charge", new Dictionary<string, object>
        {
            { "user", move.User },
        }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnBeforeMove(IExecutingMove move)
    {
        move.User.Volatile.Remove(ScriptUtils.ResolveName<ChargeFlyEffect>());
    }
}